// Generated from libavcodec/vulkan/ffv1_common.comp
const char *ff_source_ffv1_common_comp =
"/*\n"
" * FFv1 codec\n"
" *\n"
" * Copyright (c) 2024 Lynne <dev@lynne.ee>\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"struct SliceContext {\n"
"    RangeCoder c;\n"
"\n"
"#ifdef GOLOMB\n"
"    PutBitContext pb; /* 8*8 bytes */\n"
"#endif\n"
"\n"
"    ivec2 slice_dim;\n"
"    ivec2 slice_pos;\n"
"    ivec2 slice_rct_coef;\n"
"\n"
"    uint hdr_len; // only used for golomb\n"
"    int slice_coding_mode;\n"
"};\n"
"\n"
"/* -1, { -1, 0 } */\n"
"int predict(int L, ivec2 top)\n"
"{\n"
"    return mid_pred(L, L + top[1] - top[0], top[1]);\n"
"}\n"
"\n"
"/* { -2, -1 }, { -1, 0, 1 }, 0 */\n"
"int get_context(VTYPE2 cur_l, VTYPE3 top_l, TYPE top2, uint8_t quant_table_idx)\n"
"{\n"
"    const int LT = top_l[0]; /* -1 */\n"
"    const int T  = top_l[1]; /*  0 */\n"
"    const int RT = top_l[2]; /*  1 */\n"
"    const int L  = cur_l[1]; /* -1 */\n"
"\n"
"    int base = quant_table[quant_table_idx][0][(L - LT) & MAX_QUANT_TABLE_MASK] +\n"
"               quant_table[quant_table_idx][1][(LT - T) & MAX_QUANT_TABLE_MASK] +\n"
"               quant_table[quant_table_idx][2][(T - RT) & MAX_QUANT_TABLE_MASK];\n"
"\n"
"    if ((quant_table[quant_table_idx][3][127] == 0) &&\n"
"        (quant_table[quant_table_idx][4][127] == 0))\n"
"        return base;\n"
"\n"
"    const int TT = top2;     /* -2 */\n"
"    const int LL = cur_l[0]; /* -2 */\n"
"    return base +\n"
"           quant_table[quant_table_idx][3][(LL - L) & MAX_QUANT_TABLE_MASK] +\n"
"           quant_table[quant_table_idx][4][(TT - T) & MAX_QUANT_TABLE_MASK];\n"
"}\n"
"\n"
"const uint32_t log2_run[41] = {\n"
"     0,  0,  0,  0,  1,  1,  1,  1,\n"
"     2,  2,  2,  2,  3,  3,  3,  3,\n"
"     4,  4,  5,  5,  6,  6,  7,  7,\n"
"     8,  9, 10, 11, 12, 13, 14, 15,\n"
"    16, 17, 18, 19, 20, 21, 22, 23,\n"
"    24,\n"
"};\n"
;
