// Generated from libavcodec/vulkan/ffv1_enc_ac.comp
const char *ff_source_ffv1_enc_ac_comp =
"/*\n"
" * Copyright (c) 2024 Lynne <dev@lynne.ee>\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"void put_rac(inout RangeCoder c, uint64_t state, bool bit)\n"
"{\n"
"    put_rac_norenorm(c, state, bit);\n"
"    if (c.range < 0x100)\n"
"        renorm_encoder(c);\n"
"}\n"
"\n"
"/* Note - only handles signed values */\n"
"void put_symbol(inout RangeCoder c, uint64_t state, int v)\n"
"{\n"
"    bool is_nil = (v == 0);\n"
"    put_rac(c, state, is_nil);\n"
"    if (is_nil)\n"
"        return;\n"
"\n"
"    const int a = abs(v);\n"
"    const int e = findMSB(a);\n"
"\n"
"    state += 1;\n"
"    for (int i = 0; i < e; i++)\n"
"        put_rac(c, state + min(i, 9), true);\n"
"    put_rac(c, state + min(e, 9), false);\n"
"\n"
"    state += 21;\n"
"    for (int i = e - 1; i >= 0; i--)\n"
"        put_rac(c, state + min(i, 9), bool(bitfieldExtract(a, i, 1)));\n"
"\n"
"    put_rac(c, state - 11 + min(e, 10), v < 0);\n"
"}\n"
"\n"
"void encode_line_pcm(inout SliceContext sc, int y, int p, int comp,\n"
"                     int bits)\n"
"{\n"
"    ivec2 sp = sc.slice_pos;\n"
"    int w = sc.slice_dim.x;\n"
"    if (p > 0 && p < 3) {\n"
"        w >>= chroma_shift.x;\n"
"        sp >>= chroma_shift;\n"
"    }\n"
"\n"
"    for (int x = 0; x < w; x++) {\n"
"        uint v = imageLoad(src[p], (sp + ivec2(x, y)))[comp];\n"
"        for (int i = (bits - 1); i >= 0; i--)\n"
"            put_rac_equi(sc.c, bool(bitfieldExtract(v, i, 1)));\n"
"    }\n"
"}\n"
"\n"
"void encode_line(inout SliceContext sc, uint64_t state,\n"
"                 int y, int p, int comp, int bits, const int run_index)\n"
"{\n"
"    ivec2 sp = sc.slice_pos;\n"
"\n"
"    int w = sc.slice_dim.x;\n"
"    if (p > 0 && p < 3) {\n"
"        w >>= chroma_shift.x;\n"
"        sp >>= chroma_shift;\n"
"    }\n"
"\n"
"    for (int x = 0; x < w; x++) {\n"
"        const ivec2 d = get_diff(sp + ivec2(x, y), ivec2(x, y), p, comp, w, bits);\n"
"        put_symbol(sc.c, state + CONTEXT_SIZE*d[0], d[1]);\n"
"    }\n"
"}\n"
;
