// Generated from libavcodec/vulkan/ffv1_enc_common.comp
const char *ff_source_ffv1_enc_common_comp =
"/*\n"
" * FFv1 codec\n"
" *\n"
" * Copyright (c) 2024 Lynne <dev@lynne.ee>\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"ivec2 get_diff(ivec2 pos, ivec2 off, int p, int comp, int sw, int bits)\n"
"{\n"
"    const ivec2 yoff_border1 = off.x == 0 ? ivec2(1, -1) : ivec2(0, 0);\n"
"    const ivec2 yoff_border2 = off.x == 1 ? ivec2(1, -1) : ivec2(0, 0);\n"
"\n"
"    TYPE top2 = TYPE(0);\n"
"    if (off.y > 1)\n"
"        top2 = TYPE(imageLoad(src[p], pos + ivec2(0, -2))[comp]);\n"
"\n"
"    VTYPE3 top  = VTYPE3(TYPE(0),\n"
"                         TYPE(0),\n"
"                         TYPE(0));\n"
"    if (off.y > 0 && off != ivec2(0, 1))\n"
"        top[0] = TYPE(imageLoad(src[p], pos + ivec2(-1, -1) + yoff_border1)[comp]);\n"
"    if (off.y > 0) {\n"
"        top[1] = TYPE(imageLoad(src[p], pos + ivec2(0, -1))[comp]);\n"
"        top[2] = TYPE(imageLoad(src[p], pos + ivec2(min(1, sw - off.x - 1), -1))[comp]);\n"
"    }\n"
"\n"
"    VTYPE3 cur = VTYPE3(TYPE(0),\n"
"                        TYPE(0),\n"
"                        imageLoad(src[p], pos)[comp]);\n"
"    if (off.x > 0 && off != ivec2(1, 0))\n"
"        cur[0] = TYPE(imageLoad(src[p], pos + ivec2(-2,  0) + yoff_border2)[comp]);\n"
"    if (off != ivec2(0, 0))\n"
"        cur[1] = TYPE(imageLoad(src[p], pos + ivec2(-1,  0) + yoff_border1)[comp]);\n"
"\n"
"    /* context, diff */\n"
"    ivec2 d = ivec2(get_context(VTYPE2(cur), top, top2, context_model),\n"
"                    cur[2] - predict(cur[1], VTYPE2(top)));\n"
"\n"
"    if (d[0] < 0)\n"
"        d = -d;\n"
"\n"
"    d[1] = fold(d[1], bits);\n"
"\n"
"    return d;\n"
"}\n"
"\n"
"void finalize_slice(inout SliceContext sc, const uint slice_idx)\n"
"{\n"
"#ifdef GOLOMB\n"
"    uint32_t enc_len = sc.hdr_len + flush_put_bits(sc.pb);\n"
"#else\n"
"    uint32_t enc_len = rac_terminate(sc.c);\n"
"#endif\n"
"\n"
"    u8buf bs = u8buf(sc.c.bytestream_start);\n"
"\n"
"    /* Append slice length */\n"
"    u8vec4 enc_len_p = unpack8(enc_len);\n"
"    bs[enc_len + 0].v = enc_len_p.z;\n"
"    bs[enc_len + 1].v = enc_len_p.y;\n"
"    bs[enc_len + 2].v = enc_len_p.x;\n"
"    enc_len += 3;\n"
"\n"
"    /* Calculate and write CRC */\n"
"    if (ec != 0) {\n"
"        bs[enc_len].v = uint8_t(0);\n"
"        enc_len++;\n"
"\n"
"        uint32_t crc = crcref;\n"
"        for (int i = 0; i < enc_len; i++)\n"
"            crc = crc_ieee[(crc & 0xFF) ^ uint32_t(bs[i].v)] ^ (crc >> 8);\n"
"\n"
"        if (crcref != 0x00000000)\n"
"            crc ^= 0x8CD88196;\n"
"\n"
"        u8vec4 crc_p = unpack8(crc);\n"
"        bs[enc_len + 0].v = crc_p.x;\n"
"        bs[enc_len + 1].v = crc_p.y;\n"
"        bs[enc_len + 2].v = crc_p.z;\n"
"        bs[enc_len + 3].v = crc_p.w;\n"
"        enc_len += 4;\n"
"    }\n"
"\n"
"    slice_results[slice_idx*2 + 0] = enc_len;\n"
"    slice_results[slice_idx*2 + 1] = uint64_t(bs) - uint64_t(out_data);\n"
"}\n"
;
