// Generated from libavcodec/vulkan/ffv1_enc_rgb.comp
const char *ff_source_ffv1_enc_rgb_comp =
"/*\n"
" * FFv1 codec\n"
" *\n"
" * Copyright (c) 2024 Lynne <dev@lynne.ee>\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"void encode_slice_rgb(inout SliceContext sc, const uint slice_idx)\n"
"{\n"
"    int bits = 9;\n"
"    if (bits != 8 || sc.slice_coding_mode != 0)\n"
"        bits = bits_per_raw_sample + int(sc.slice_coding_mode != 1);\n"
"\n"
"    int run_index = 0;\n"
"\n"
"#ifndef GOLOMB\n"
"    if (sc.slice_coding_mode == 1) {\n"
"        if (transparency == 1) {\n"
"            for (int y = 0; y < sc.slice_dim.y; y++) {\n"
"                encode_line_pcm(sc, y, 0, 1, bits);\n"
"                encode_line_pcm(sc, y, 0, 2, bits);\n"
"                encode_line_pcm(sc, y, 0, 0, bits);\n"
"                encode_line_pcm(sc, y, 0, 3, bits);\n"
"            }\n"
"        } else {\n"
"            for (int y = 0; y < sc.slice_dim.y; y++) {\n"
"                encode_line_pcm(sc, y, 0, 1, bits);\n"
"                encode_line_pcm(sc, y, 0, 2, bits);\n"
"                encode_line_pcm(sc, y, 0, 0, bits);\n"
"            }\n"
"        }\n"
"    } else\n"
"#endif\n"
"    {\n"
"        uint64_t slice_state_off = uint64_t(slice_state) +\n"
"                                   slice_idx*plane_state_size*codec_planes;\n"
"\n"
"        if (transparency == 1) {\n"
"            for (int y = 0; y < sc.slice_dim.y; y++) {\n"
"                encode_line(sc, slice_state_off + plane_state_size*0,\n"
"                            y, 0, 1, bits, run_index);\n"
"                encode_line(sc, slice_state_off + plane_state_size*1,\n"
"                            y, 0, 2, bits, run_index);\n"
"                encode_line(sc, slice_state_off + plane_state_size*1,\n"
"                            y, 0, 0, bits, run_index);\n"
"                encode_line(sc, slice_state_off + plane_state_size*2,\n"
"                            y, 0, 3, bits, run_index);\n"
"            }\n"
"        } else {\n"
"            for (int y = 0; y < sc.slice_dim.y; y++) {\n"
"                encode_line(sc, slice_state_off + plane_state_size*0,\n"
"                            y, 0, 1, bits, run_index);\n"
"                encode_line(sc, slice_state_off + plane_state_size*1,\n"
"                            y, 0, 2, bits, run_index);\n"
"                encode_line(sc, slice_state_off + plane_state_size*1,\n"
"                            y, 0, 0, bits, run_index);\n"
"            }\n"
"        }\n"
"    }\n"
"\n"
"    finalize_slice(sc, slice_idx);\n"
"}\n"
"\n"
"void main(void)\n"
"{\n"
"    const uint slice_idx = gl_WorkGroupID.y*gl_NumWorkGroups.x + gl_WorkGroupID.x;\n"
"    encode_slice_rgb(slice_ctx[slice_idx], slice_idx);\n"
"}\n"
;
