// Generated from libavcodec/vulkan/ffv1_enc_vlc.comp
const char *ff_source_ffv1_enc_vlc_comp =
"/*\n"
" * FFv1 codec\n"
" *\n"
" * Copyright (c) 2024 Lynne <dev@lynne.ee>\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"struct RLEState {\n"
"    int count;\n"
"    int diff;\n"
"    int index;\n"
"    bool mode;\n"
"};\n"
"\n"
"void calc_new_state(inout RLEState state, int context)\n"
"{\n"
"    if (context == 0)\n"
"        state.mode = false;\n"
"\n"
"    if (!state.mode)\n"
"        return;\n"
"\n"
"    if (state.diff > 0) {\n"
"        while (state.count >= (1 << log2_run[state.index])) {\n"
"            state.count -= 1 << log2_run[state.index];\n"
"            state.index++;\n"
"        }\n"
"        if (state.index > 0)\n"
"            state.index--;\n"
"        state.count = 0;\n"
"        state.mode = false;\n"
"        if (state.diff > 0)\n"
"            state.diff--;\n"
"    } else {\n"
"        state.count++;\n"
"    }\n"
"}\n"
"\n"
"void encode_line(inout SliceContext sc, uint64_t state,\n"
"                 int y, int p, int comp, int bits, inout int run_index)\n"
"{\n"
"    ivec2 sp = sc.slice_pos;\n"
"\n"
"    int w = sc.slice_dim.x;\n"
"    if (p > 0 && p < 3) {\n"
"        w >>= chroma_shift.x;\n"
"        sp >>= chroma_shift;\n"
"    }\n"
"\n"
"    int run_count = 0;\n"
"    bool run_mode = false;\n"
"\n"
"    for (int x = 0; x < w; x++) {\n"
"        ivec2 d = get_diff(sp + ivec2(x, y), ivec2(x, y), p, comp, w, bits);\n"
"\n"
"        if (d[0] == 0)\n"
"            run_mode = true;\n"
"\n"
"        if (run_mode) {\n"
"            if (d[1] != 0) {\n"
"                /* A very unlikely loop */\n"
"                while (run_count >= 1 << log2_run[run_index]) {\n"
"                    run_count -= 1 << log2_run[run_index];\n"
"                    run_index++;\n"
"                    put_bits(sc.pb, 1, 1);\n"
"                }\n"
"\n"
"                put_bits(sc.pb, 1 + log2_run[run_index], run_count);\n"
"                if (run_index != 0)\n"
"                    run_index--;\n"
"                run_count = 0;\n"
"                run_mode  = false;\n"
"                if (d[1] > 0)\n"
"                    d[1]--;\n"
"            } else {\n"
"                run_count++;\n"
"            }\n"
"        }\n"
"\n"
"        if (!run_mode) {\n"
"            VlcState sb = VlcState(state + VLC_STATE_SIZE*d[0]);\n"
"            Symbol sym = get_vlc_symbol(sb, d[1], bits);\n"
"            put_bits(sc.pb, sym.bits, sym.val);\n"
"        }\n"
"    }\n"
"\n"
"    if (run_mode) {\n"
"        while (run_count >= (1 << log2_run[run_index])) {\n"
"            run_count -= 1 << log2_run[run_index];\n"
"            run_index++;\n"
"            put_bits(sc.pb, 1, 1);\n"
"        }\n"
"\n"
"        if (run_count > 0)\n"
"            put_bits(sc.pb, 1, 1);\n"
"    }\n"
"}\n"
;
